## virtualbox 4.1.42-dfsg

=== debian/changelog ===
virtualbox (4.1.42-dfsg-1+deb7u1) wheezy-security; urgency=medium

  * New upstream release.
     - Addressed CVE-2015-4813 and CVE-2015-4896

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 26 Oct 2015 12:14:36 +0100

virtualbox (4.1.40-dfsg-1+deb7u1) wheezy-security; urgency=medium

  * New upstream release.
  * Remove all the CVE related patches, and refresh patches.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Aug 2015 16:01:27 +0200

virtualbox (4.1.18-dfsg-2+deb7u5) wheezy-security; urgency=medium

  * d/p/CVE-2015-3456.patch fix for CVE-2015-3456 a.k.a. VENOM
    (Closes: #785424)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 18 May 2015 18:32:20 +0200

virtualbox (4.1.18-dfsg-2+deb7u4) wheezy-security; urgency=medium

  [ Frank Mehnert ]
  * fix security vulnerabilities (Closes: #775888)
     CVE-2015-0377, CVE-2015-0418
     - debian/patches/CVE-2015-0{377,418}.patch

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 22 Jan 2015 14:21:14 +0100

virtualbox (4.1.18-dfsg-2+deb7u3) wheezy-security; urgency=high

  * Fix memory corruption vulnerabilities in 3D acceleration. (Closes: #741602)
    - CVE-2014-0981, CVE-2014-0983
    - Backport fixes from version 4.1.32 in debian/patches/CVE-2014-0981.patch
      and debian/patches/CVE-2014-0983.patch

 -- Felix Geyer <fgeyer@debian.org>  Mon, 14 Apr 2014 11:19:01 +0200

virtualbox (4.1.18-dfsg-2+deb7u2) wheezy-security; urgency=high

  * Apply fixes from the January 2014 security advisory. (Closes: #735410)
    - Add debian/patches/38-security-fixes-2014-01.patch
    - CVE-2013-5892, CVE-2014-0407, CVE-2014-0406, CVE-2014-0404

 -- Felix Geyer <fgeyer@debian.org>  Sun, 09 Mar 2014 19:46:52 +0100

virtualbox (4.1.18-dfsg-2+deb7u1) unstable; urgency=high

  * Fix build failure with the Debian wheezy kernel which backports the drm
    subsystem from Linux 3.4. (Closes: #703358)
  * Set urgency to high as it fixes an RC bug.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 31 Mar 2013 20:45:16 +0200

virtualbox (4.1.18-dfsg-2) unstable; urgency=high

  [ John Paul Adrian Glaubitz ]
  * Include patch to fix virtual graphics device user
    vulnerability CVE-2013-0420. (Closes: #698292)

 -- Felix Geyer <debfx-pkg@fobos.de>  Sat, 19 Jan 2013 18:05:25 +0100

=== debian/control ===
Source: virtualbox
Section: misc
Priority: optional
Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>,
           Felix Geyer <debfx-pkg@fobos.de>
DM-Upload-Allowed: yes
Build-Depends: bcc,
               bzip2,
               debhelper (>= 7.2.7~),
               default-jdk,
               dkms (>= 2.1.1.1),
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.15.6~),
               g++-multilib [amd64],
               genisoimage,
               gsoap,
               iasl,
               imagemagick,
               kbuild (>= 1:0.1.9998svn2537),
               libasound2-dev,
               libcap-dev,
               libcurl4-openssl-dev,
               libdrm-dev,
               libfuse-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libidl-dev,
               libpam0g-dev,
               libpixman-1-dev,
               libpng-dev,
               libpulse-dev,
               libqt4-dev (>= 4.4.0),
               libqt4-opengl-dev (>= 4.4.0),
               libsdl1.2-dev,
               libssl-dev,
               libvncserver-dev,
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxi-dev,
               libxinerama-dev,
               libxmu-dev,
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               lsb-release,
               lynx-cur,
               makeself,
               python-dev (>= 2.6.6-3~),
               texlive-fonts-extra,
               texlive-fonts-recommended,
               texlive-latex-extra,
               texlive-latex-recommended,
               uuid-dev,
               x11proto-gl-dev,
               x11proto-xf86dri-dev,
               xserver-xorg-dev,
               xsltproc,
               yasm (>= 0.7.0),
               zlib1g-dev
X-Python-Version: >= 2.5
Standards-Version: 3.9.3
Homepage: http://www.virtualbox.org/
Vcs-Git: git://git.debian.org/git/pkg-virtualbox/virtualbox.git
Vcs-Browser: http://git.debian.org/?p=pkg-virtualbox/virtualbox.git

Package: virtualbox-qt
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         virtualbox (= ${binary:Version})
Breaks: virtualbox-ose-qt (<< 4.0.6-dfsg-1~),
        virtualbox (<< 4.1.6-dfsg-2~)
Replaces: virtualbox-ose-qt (<< 4.0.6-dfsg-1~),
          virtualbox-ose (<< 2.2.0-dfsg-1~),
          virtualbox (<< 4.1.6-dfsg-2~)
Description: x86 virtualization solution - Qt based user interface
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the Qt based graphical user interface for VirtualBox.

Package: virtualbox
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python:Depends},
         adduser
Recommends: virtualbox-dkms (= ${source:Version}) | virtualbox-source (= ${source:Version}),
            virtualbox-qt (= ${binary:Version}),
            ${shlibs:Recommends}
Suggests: virtualbox-guest-additions-iso,
          vde2
Conflicts: virtualbox-2.0, virtualbox-2.1, virtualbox-2.2, virtualbox-3.0
Breaks: virtualbox-ose (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - base binaries
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the binaries for VirtualBox. Either the virtualbox-dkms
 or the virtualbox-source package is also required in order to compile the
 kernel modules needed for virtualbox. A graphical user interface for
 VirtualBox is provided by the package virtualbox-qt.

Package: virtualbox-dbg
Section: debug
Priority: extra
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends},
         virtualbox (= ${binary:Version}) | virtualbox-guest-utils (= ${binary:Version})
Breaks: virtualbox-ose-dbg (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-dbg (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - debugging symbols
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the debugging symbols for VirtualBox.

Package: virtualbox-dkms
Section: kernel
Architecture: all
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends}, virtualbox (>= ${source:Version})
Breaks: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~),
          virtualbox-ose-source (<< 3.1.0-dfsg-1~)
Description: x86 virtualization solution - kernel module sources for dkms
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox kernel module to be
 build with dkms. Kernel sources or headers are required to compile this
 module.

Package: virtualbox-source
Section: kernel
Architecture: all
Depends: ${misc:Depends},
         build-essential,
         debhelper (>= 5),
         bzip2,
         kbuild
Recommends: module-assistant
Breaks: virtualbox-ose-source (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-source (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - kernel module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox kernel module.
 The virtualbox package is also required in order to make use of these
 modules. Kernel sources or headers are required to compile this module.

Package: virtualbox-guest-dkms
Section: kernel
Architecture: all
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends},
         virtualbox-guest-utils (>= ${source:Version})
Breaks: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~),
          virtualbox-ose-guest-source (<< 3.1.0-dfsg-1~)
XB-Modaliases: ${modaliases}
Description: x86 virtualization solution - guest addition module source for dkms
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules to be build with dkms. Kernel sources or headers are required to
 compile these modules.

Package: virtualbox-guest-source
Section: kernel
Architecture: all
Depends: ${misc:Depends}, 
         build-essential,
         debhelper (>= 5),
         bzip2,
         kbuild
Recommends: module-assistant
Breaks: virtualbox-ose-guest-source (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-source (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - guest addition module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules. The virtualbox-guest-utils package is also required in order to
 make use of these modules. Kernel sources or headers are required to compile
 these modules.

Package: virtualbox-guest-x11
Section: x11
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${xserver:Depends},
         virtualbox-guest-utils (= ${binary:Version})
Provides: ${xviddriver:Provides}
Breaks: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~),
          virtualbox-ose-guest-utils (<< 2.2.0-dfsg-1~)
Description: x86 virtualization solution - X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the X11 guest utilities for VirtualBox. These utilities
 are meant to be run inside the virtual machine.
 They provide closer integration and improve the interactive performance.

Package: virtualbox-guest-utils
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         pciutils
Recommends: virtualbox-guest-dkms (= ${source:Version}) | virtualbox-guest-source (= ${source:Version}),
            virtualbox-guest-x11 (= ${binary:Version})
Breaks: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - non-X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the non-X11 guest utilities for VirtualBox. These
 utilities are meant to be run inside the virtual machine.
 They provide closer integration and allow to share data through shared folders
 between the host system and the virtual machine.

Package: virtualbox-fuse
Architecture: amd64 i386
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${shlibs:Depends},
         ${misc:Depends},
         virtualbox (= ${binary:Version})
Breaks: virtualbox-ose-fuse (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-fuse (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - virtual filesystem
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides a FUSE-based VFS (Virtual FileSystem) to mount a
 VirtualBox disk so all partitions can be loop-mounted.

Package: virtualbox-ose-qt
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-qt
Description: transitional package for virtualbox-qt
 This is a dummy transitional package for virtualbox-qt and can be
 safely removed after the installation is complete.

Package: virtualbox-ose
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox
Description: transitional package for virtualbox
 This is a dummy transitional package for virtualbox and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-dbg
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-dbg
Description: transitional package for virtualbox-dbg
 This is a dummy transitional package for virtualbox-dbg and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-dkms
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-dkms
Description: transitional package for virtualbox-dkms
 This is a dummy transitional package for virtualbox-dkms and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-source
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-source
Description: transitional package for virtualbox-source
 This is a dummy transitional package for virtualbox-source and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-guest-dkms
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-guest-dkms
Description: transitional package for virtualbox-guest-dkms
 This is a dummy transitional package for virtualbox-guest-dkms and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-guest-source
Section: oldlibs
Priority: extra

=== debian/rules ===
#!/usr/bin/make -f

# Name of the source packages
psource:=virtualbox-source
gsource:=virtualbox-guest-source
pdkms:=virtualbox-dkms
gdkms:=virtualbox-guest-dkms

# The short upstream name
sname:=virtualbox
sxname:=virtualbox-qt
gname:=virtualbox-guest
uname:=virtualbox-guest-utils
uxname:=virtualbox-guest-x11
fname:=virtualbox-fuse

INSTALL_PATH:=/usr/lib/virtualbox
MAKE:=kmk

upstreamversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')

pkgs_xzcompress = $(shell dh_listpackages | grep -v -e ose -e source)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)

XSERVER_VERSION = 17
XORG_PKG_ABI = 3

ifeq ($(DIST_RELEASE),Debian/squeeze)
	XORG_PKG_ABI = 2
endif

ifeq ($(DIST_RELEASE),Ubuntu/maverick)
	XORG_PKG_ABI = 2
endif

ifeq ($(DIST_RELEASE),Ubuntu/lucid)
	XORG_PKG_ABI = 1
endif


ifeq ($(XORG_PKG_ABI),3)
	VIDEODEP = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)

	SERVER_DEPENDS = $(VIDEODEP)
	VIDDRIVER_PROVIDES = xorg-driver-video

	ifeq ($(strip $(VIDEODEP)),)
		XORG_PKG_ABI_ERROR = VIDEODEP is empty
	endif
endif
ifeq ($(XORG_PKG_ABI),2)
	VIDEODEP = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)
	VIDEOABI = $(shell cat /usr/share/xserver-xorg/videoabiver 2>/dev/null)

	SERVER_DEPENDS = $(VIDEODEP)
	VIDDRIVER_PROVIDES = xserver-xorg-video-$(VIDEOABI)

	ifeq ($(strip $(VIDEODEP)),)
		XORG_PKG_ABI_ERROR = VIDEODEP is empty
	endif
	ifeq ($(strip $(VIDEOABI)),)
		XORG_PKG_ABI_ERROR = VIDEOABI is empty
	endif
endif
ifeq ($(XORG_PKG_ABI),1)
	SERVERMINVERS = $(shell cat /usr/share/xserver-xorg/serverminver 2>/dev/null)
	VIDEOABI = $(shell cat /usr/share/xserver-xorg/videoabiver 2>/dev/null)

	SERVER_DEPENDS = xserver-xorg-core (>= $(SERVERMINVERS))
	VIDDRIVER_PROVIDES = xserver-xorg-video-$(VIDEOABI)

	ifeq ($(strip $(SERVERMINVERS)),)
		XORG_PKG_ABI_ERROR = SERVERMINVERS is empty
	endif
	ifeq ($(strip $(VIDEOABI)),)
		XORG_PKG_ABI_ERROR = VIDEOABI is empty
	endif
endif



%:
	dh $@ --with python2,dkms

override_dh_auto_configure:
	@echo Building for $(DIST_RELEASE)

ifdef XORG_PKG_ABI_ERROR
	@echo 'error: $(XORG_PKG_ABI_ERROR)'
	@exit 1
endif

	mkdir -p out
	./configure \
	    --ose \
	    --odir=$(abspath out) \
	    --with-linux="/usr" \
	    --disable-kmods \
	    --enable-webservice \
	    --enable-vde \
	    --enable-vnc

override_dh_auto_build:
	# Building package
	. out/env.sh && $(MAKE) \
	    AUTOCFG=$(abspath out/AutoConfig.kmk) \
	    LOCALCFG=$(abspath debian/LocalConfig.kmk) \
	    PATH_OUT=$(abspath out) \
	    TOOL_YASM_AS=yasm \
	    XSERVER_VERSION=$(XSERVER_VERSION) \
	    VBOX_BUILD_PUBLISHER=_$(DIST_NAME) \
	    VBOX_WITH_REGISTRATION_REQUEST= \
	    VBOX_WITH_UPDATE_REQUEST= \
	    KBUILD_VERBOSE=2

	mkdir -p out/vdfuse
	gcc debian/vdfuse/vdfuse.c -o out/vdfuse/vdfuse -pipe -g -Wl,--as-needed -Wl,--rpath,$(INSTALL_PATH) -Wall \
	    $(shell pkg-config --cflags --libs fuse) -Iinclude $(addprefix out/bin/, \
	    VBoxDD.so VBoxDD2.so VBoxDDU.so VBoxVMM.so VBoxREM.so VBoxRT.so)

	xsltproc --nonet --stringparam section.autolabel 1 \
	    -o debian/README.Debian.html \
	    /usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
	    debian/virtualbox.files/README.Debian.xml

	chmod 755 debian/lynx-dump-postprocess
	export LC_ALL=C; lynx -force_html -dump debian/README.Debian.html | \
	    ./debian/lynx-dump-postprocess > debian/virtualbox.README.Debian.tmp
	mv debian/virtualbox.README.Debian.tmp debian/virtualbox.README.Debian

override_dh_auto_install:
	dh_auto_install

	export VBOX_INSTALL_PATH=$(INSTALL_PATH) && \
	    cd out/bin/sdk/installer && \
	    python ./vboxapisetup.py install --root $(CURDIR)/debian/$(sname)

	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).links.in > debian/$(gdkms).links
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).links.in > debian/$(pdkms).links

	# Build install files for the dkms'ified sources
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).install.in > debian/$(pdkms).install
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).install.in > debian/$(gdkms).install

	echo "xserver:Depends=$(SERVER_DEPENDS)" >> debian/$(uxname).substvars
	echo "xviddriver:Provides=$(VIDDRIVER_PROVIDES)" >> debian/$(uxname).substvars
	echo "xinpdriver:Provides=$(INPDRIVER_PROVIDES)" >> debian/$(uxname).substvars

ifeq ($(DIST_NAME),Ubuntu)
	echo "modaliases=vboxguest(pci:v000080EEd0000CAFEsv00000000sd00000000bc*sc*i*)" >> debian/$(gdkms).substvars
endif

override_dh_install:
	dh_install -p$(sname) -X out/bin/VBoxDbg.so
	dh_install --remaining-packages

	convert debian/$(sxname)/usr/share/icons/hicolor/32x32/apps/virtualbox.png \
	    debian/$(sxname)/usr/share/pixmaps/virtualbox.xpm

ifeq ($(DIST_NAME),Ubuntu)
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(sname)/usr/share/apport/package-hooks/source_$(sname).py
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(gdkms)/usr/share/apport/package-hooks/$(gdkms).py
endif

override_dh_link:
	dh_link
	dh_link -p$(uxname) --ignore debian/$(uxname).links \
	    /usr/lib/VBoxOGL.so $(shell pkg-config --variable dridriverdir dri)/vboxvideo_dri.so

override_dh_fixperms:
	dh_fixperms

	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxSDL
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxHeadless
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetDHCP
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetAdpCtl
	chmod +s debian/$(sxname)$(INSTALL_PATH)/VirtualBox

	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.gc
	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.r0

	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/server/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/client/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/java/vboxjxpcom.jar

	chmod 755 debian/$(uxname)/usr/share/virtualbox/x11config.pl
	chmod 755 debian/$(sname)/usr/share/virtualbox/VBox.sh

# check if arch-all packages are being built
ifneq (,$(filter $(psource), $(shell dh_listpackages)))
	# These files have incorrect permissions, fixing it.
	chmod 755 debian/$(psource)/usr/src/modules/$(sname)/debian/rules
	chmod 755 debian/$(gsource)/usr/src/modules/$(gname)/debian/rules

	# this needs all prior work to be finished
	cd debian/$(psource)/usr/src && \
	    tar -cjf $(sname).tar.bz2 modules && \
	    rm -rf modules
	cd debian/$(gsource)/usr/src && \
	    tar -cjf $(gname).tar.bz2 modules && \
	    rm -rf modules

	chmod 644 debian/$(psource)/usr/src/$(sname).tar.bz2
	chmod 644 debian/$(gsource)/usr/src/$(gname).tar.bz2
endif

override_dh_installinit:
	dh_installinit --no-start

override_dh_dkms:
	dh_dkms -V $(upstreamversion)

override_dh_strip:
	dh_strip --dbg-package=$(sname)-dbg

	# strip files not handled by dh_strip
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	set -e && for file in debian/$(sname)/usr/lib/virtualbox/*.gc debian/$(sname)/usr/lib/virtualbox/*.r0; do \
	    strip --strip-debug --remove-section=.comment --remove-section=.note $${file}; \
	done
endif

override_dh_shlibdeps:
	dh_shlibdeps -p$(sname) -X debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -- \
	    -dRecommends debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -dDepends
	dh_shlibdeps --remaining-packages

override_dh_compress:
	dh_compress -X.pdf

override_dh_builddeb:
	dh_builddeb $(foreach pkg,$(pkgs_xzcompress),-p$(pkg)) -- -Zxz
	dh_builddeb --remaining-packages

override_dh_auto_clean:
	dh_auto_clean

	# Cleaning package
	rm -rf out
	rm -f build-stamp
	rm -f debian/virtualbox.README.Debian debian/README.Debian.html
	rm -f debian/$(pdkms).install
	rm -f debian/$(gdkms).install
	rm -f debian/$(pdkms).links
	rm -f debian/$(gdkms).links

	find . -name "*.pyc" -exec rm -f {} \;

#Rebuild the orig.tar.gz
dfsg-free: clean
	rm -rf ./kBuild
	rm -rf ./tools
	rm -rf ./src/VBox/Additions/os2
	rm -rf ./src/VBox/Additions/WINNT

## virtualbox 4.1.44-dfsg

=== debian/changelog ===
virtualbox (4.1.44-dfsg-1+deb7u1ubuntu1) precise-security; urgency=medium

  * New upstream release. (LP: #1517161)
    - drop patches and rebase with debian wheezy-security upload
    - all CVEs are fixed in the upstream import, drop all the CVE
      patches.
  * Add two patches, to comply with build failures (build and module build)
    - fix-ipv6-build.patch
    - fix-module-build.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Nov 2015 12:37:21 +0100

virtualbox (4.1.12-dfsg-2ubuntu0.10) precise-security; urgency=medium

  * d/p/CVE-2015-3456.patch fix for CVE-2015-3456 a.k.a. VENOM
    (Closes: #785424, LP: #1456553)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Tue, 19 May 2015 12:15:56 +0200

virtualbox (4.1.12-dfsg-2ubuntu0.9) precise-security; urgency=medium

  [ Seth Arnold standardizing the changelog entry ]
  * SECURITY UPDATE: multiple flaws (LP: #1413603)
     - debian/patches/CVE-2015-0418.patch
     - debian/patches/CVE-2015-0377.patch
     - CVE-2015-0377
     - CVE-2015-0418

  [ Frank Mehnert ]
  * fix security vulnerabilities (Closes: #775888)
     CVE-2015-0377, CVE-2015-0418
     - debian/patches/CVE-2015-0{377,418}.patch

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 22 Jan 2015 14:49:47 +0100

virtualbox (4.1.12-dfsg-2ubuntu0.8) precise; urgency=medium

  * Add support for Virtualbox host kernel modules on Linux 3.5
    (LP: #1408939).

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 09 Jan 2015 11:48:31 +0100

virtualbox (4.1.12-dfsg-2ubuntu0.7) precise; urgency=low

  * Add support for VirtualBox host kernel modules on Linux 3.13
    (LP: #1292118).

 -- Corey Wright <undefined+ubuntu@pobox.com>  Sun, 14 Dec 2014 18:58:12 -0600

virtualbox (4.1.12-dfsg-2ubuntu0.6) precise-security; urgency=medium

  * SECURITY UPDATE: Virtual graphics device user vulnerability (LP: #1307725)
    - debian/patches/CVE-2013-0420.patch: backport upstream patch
    - CVE-2013-0420
  * SECURITY UPDATE: Apply fixes from the January 2014 security advisory
    - debian/patches/38-security-fixes-2014-01.patch: backport upstream fixes
    - CVE-2013-5892, CVE-2014-0407, CVE-2014-0406, CVE-2014-0404
  * SECURITY UPDATE: Fix memory corruption vulnerabilities in 3D acceleration
    - debian/patches/CVE-2014-0981.patch, debian/patches/CVE-2014-0983.patch:
      backport fixes from version 4.0.24
    - CVE-2014-0981, CVE-2014-0983

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 14 Apr 2014 17:37:39 +0200

virtualbox (4.1.12-dfsg-2ubuntu0.5) precise-proposed; urgency=low

  * Update the patch for Linux 3.11 with a more complete
    implementation (LP: #1076603).

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 30 Sep 2013 10:54:27 +0200

virtualbox (4.1.12-dfsg-2ubuntu0.4) precise-proposed; urgency=low

  * Add support for kernels up to 3.11 (LP: #1076603).

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 10 Sep 2013 13:49:14 +0200

virtualbox (4.1.12-dfsg-2ubuntu0.3) precise-proposed; urgency=low

  [ Felix Geyer ]
  * Fix build errors with kernel 3.5. (LP: #1081307)
    - Add 39-kernel-35.patch
  * Fix crash when running 64-bit guests on a 32-bit host system.
    (LP: #1071344)
    - Add 40-fix-crash-64bit-guests.patch
  * Fix broken DNS in guests when the NetworkManager dnsmasq resolver
    is used on the host. (LP: #1031217)
    - Add 38-fix-nat-local-dns-resolver.patch

  [ Dmitry Shachnev ]
  * Fix the changelog, refresh patches and re-upload to precise-proposed.

 -- Felix Geyer <debfx@ubuntu.com>  Sun, 31 Mar 2013 19:01:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: virtualbox
 Section: misc
 Priority: optional
-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
 Uploaders: Michael Meskes <meskes@debian.org>,
            Felix Geyer <debfx-pkg@fobos.de>
 DM-Upload-Allowed: yes
@@ -322,6 +323,3 @@
  This is a dummy transitional package for virtualbox-guest-dkms and can be
  safely removed after the installation is complete.
 
-Package: virtualbox-ose-guest-source
-Section: oldlibs
-Priority: extra

## virtualbox 4.2.10

=== src/VBox/HostDrivers/Support/linux/Makefile ===
# $Id: Makefile $
## @file
# Makefile for the VirtualBox Linux Host Driver.
#

#
#
# Copyright (C) 2006-2012 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# The contents of this file may alternatively be used under the terms
# of the Common Development and Distribution License Version 1.0
# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
# VirtualBox OSE distribution, in which case the provisions of the
# CDDL are applicable instead of those of the GPL.
#
# You may elect to license modified versions of this file under the
# terms and conditions of either the GPL or the CDDL or both.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

# override is required by the Debian guys
override MODULE = vboxdrv
OBJS   = \
	linux/SUPDrv-linux.o \
	SUPDrv.o \
	SUPDrvSem.o \
	SUPDrvTracer.o \
	r0drv/alloc-r0drv.o \
	r0drv/initterm-r0drv.o \
	r0drv/memobj-r0drv.o \
	r0drv/mpnotification-r0drv.o \
	r0drv/powernotification-r0drv.o \
	r0drv/linux/assert-r0drv-linux.o \
	r0drv/linux/alloc-r0drv-linux.o \
	r0drv/linux/initterm-r0drv-linux.o \
	r0drv/linux/memobj-r0drv-linux.o \
	r0drv/linux/memuserkernel-r0drv-linux.o \
	r0drv/linux/mp-r0drv-linux.o \
	r0drv/linux/mpnotification-r0drv-linux.o \
	r0drv/linux/process-r0drv-linux.o \
	r0drv/linux/semevent-r0drv-linux.o \
	r0drv/linux/semeventmulti-r0drv-linux.o \
	r0drv/linux/semfastmutex-r0drv-linux.o \
	r0drv/linux/semmutex-r0drv-linux.o \
	r0drv/linux/spinlock-r0drv-linux.o \
	r0drv/linux/thread-r0drv-linux.o \
	r0drv/linux/thread2-r0drv-linux.o \
	r0drv/linux/time-r0drv-linux.o \
	r0drv/linux/timer-r0drv-linux.o \
	r0drv/generic/semspinmutex-r0drv-generic.o \
	common/alloc/alloc.o \
	common/checksum/crc32.o \
	common/checksum/ipv4.o \
	common/checksum/ipv6.o \
	common/err/RTErrConvertFromErrno.o \
	common/err/RTErrConvertToErrno.o \
	common/log/log.o \
	common/log/logellipsis.o \
	common/log/logrel.o \
	common/log/logrelellipsis.o \
	common/log/logcom.o \
	common/log/logformat.o \
	common/misc/RTAssertMsg1Weak.o \
	common/misc/RTAssertMsg2.o \
	common/misc/RTAssertMsg2Add.o \
	common/misc/RTAssertMsg2AddWeak.o \
	common/misc/RTAssertMsg2AddWeakV.o \
	common/misc/RTAssertMsg2Weak.o \
	common/misc/RTAssertMsg2WeakV.o \
	common/misc/assert.o \
	common/misc/handletable.o \
	common/misc/handletablectx.o \
	common/misc/thread.o \
	common/string/RTStrCopy.o \
	common/string/RTStrCopyEx.o \
	common/string/RTStrCopyP.o \
	common/string/RTStrNCmp.o \
	common/string/RTStrNLen.o \
	common/string/stringalloc.o \
	common/string/strformat.o \
	common/string/strformatrt.o \
	common/string/strformattype.o \
	common/string/strprintf.o \
	common/string/strtonum.o \
	common/table/avlpv.o \
	common/time/time.o \
	r0drv/linux/RTLogWriteDebugger-r0drv-linux.o \
	generic/RTAssertShouldPanic-generic.o \
	generic/RTLogWriteStdErr-stub-generic.o \
	generic/RTLogWriteStdOut-stub-generic.o \
	generic/RTLogWriteUser-generic.o \
	generic/RTMpGetArraySize-generic.o \
	generic/RTSemEventWait-2-ex-generic.o \
	generic/RTSemEventWaitNoResume-2-ex-generic.o \
	generic/RTSemEventMultiWait-2-ex-generic.o \
	generic/RTSemEventMultiWaitNoResume-2-ex-generic.o \
	generic/RTTimerCreate-generic.o \
	generic/errvars-generic.o \
	generic/mppresent-generic.o \
	generic/uuid-generic.o \
	VBox/log-vbox.o
ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS += math/gcc/divdi3.o \
	math/gcc/moddi3.o \
	math/gcc/qdivrem.o \
	math/gcc/udivdi3.o \
        math/gcc/divdi3.o \
	math/gcc/umoddi3.o
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
OBJS += common/alloc/heapsimple.o
endif
ifdef VBOX_WITH_NATIVE_DTRACE
OBJS += SUPDrvDTrace.o
endif

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  # build for the current kernel, version check
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir, only for current kernel
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the support driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 INCL    += $(addprefix -I$(KBUILD_EXTMOD)/vboxdrv,/ /include /r0drv/linux)
 export INCL
endif
ifneq ($(wildcard $(KBUILD_EXTMOD)/vboxdrv),)
 MANGLING := $(KBUILD_EXTMOD)/vboxdrv/include/VBox/SUPDrvMangling.h
else
 MANGLING := $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
ifdef VBOX_REDHAT_KABI
 KFLAGS  += -DVBOX_REDHAT_KABI
endif
ifndef CONFIG_VBOXDRV_FIXEDMAJOR
 KFLAGS  += -DCONFIG_VBOXDRV_AS_MISC
endif
ifdef VBOX_WITH_NATIVE_DTRACE
 KFLAGS  += -DVBOX_WITH_NATIVE_DTRACE
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
# must be consistent with Config.kmk!
KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
 # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
 #KFLAGS  += -DIPRT_DEBUG_SEMS
endif

# 2.6 and later
MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)

# build defs
EXTRA_CFLAGS  += -include $(MANGLING) $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

# OL/UEK: disable module signing for external modules -- we don't have any private key
$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) CONFIG_MODULE_SIG= -C $(KERN_DIR) modules

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a; \
	rm -f /etc/vbox/module_not_compiled

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

else # eq ($(MAKECMDGOALS),clean)

 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifeq ($(wildcard $(KERN_DIR)/Makefile),)
   KERN_DIR := /usr/src/linux
  endif
 endif
 ifeq ($(wildcard $(KERN_DIR)/Makefile),)

clean:
	find . \( -name \*.o -o -name \*.cmd \) -print0 | xargs -0 rm -f
	rm -rf .tmp_ver* $(MODULE).* Module.symvers Modules.symvers modules.order

 else

clean:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

 endif

endif # eq($(MAKECMDGOALS),clean)

check: $(MODULE)
	@if ! readelf -p __ksymtab_strings vboxdrv.ko | grep -E "\[.*\]  *(RT|g_..*RT.*)"; then \
	    echo "All exported IPRT symbols are properly renamed!"; \
	 else \
	    echo "error: Some exported IPRT symbols was not properly renamed! See above." >&2; \
	    false; \
	 fi

=== src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Host Network Filter Driver.
# (For 2.6.x this file must be called 'Makefile'!)
#

#
#
# Copyright (C) 2006-2011 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

# override is required by the Debian guys
override MODULE = vboxnetflt
OBJS   = \
	linux/VBoxNetFlt-linux.o \
	VBoxNetFlt.o \
	SUPR0IdcClient.o \
	SUPR0IdcClientComponent.o \
	linux/SUPR0IdcClient-linux.o

ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS += math/gcc/divdi3.o \
	math/gcc/moddi3.o \
	math/gcc/qdivrem.o \
	math/gcc/udivdi3.o \
        math/gcc/divdi3.o \
	math/gcc/umoddi3.o
endif

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  # build for the current kernel, version check
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir, only for current kernel
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the support driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 INCL    += $(addprefix -I$(KBUILD_EXTMOD)/vboxnetflt,/ /include /r0drv/linux)
 export INCL
endif
ifneq ($(wildcard $(KBUILD_EXTMOD)/vboxnetflt),)
 MANGLING := $(KBUILD_EXTMOD)/vboxnetflt/include/VBox/SUPDrvMangling.h
else
 MANGLING := $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
ifdef VBOX_REDHAT_KABI
 KFLAGS  += -DVBOX_REDHAT_KABI
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
# must be consistent with Config.kmk!
KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
 # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
 #KFLAGS  += -DIPRT_DEBUG_SEMS
endif

# By default we use remap_pfn_range() kernel API to make kernel pages
# visible for userland. Unfortunately, it leads to situation that
# during debug session all structures on that page (such as PVM pointer)
# are not accessible to the debugger (see #3214).
# This code enables experimental support
# for vm_insert_page() kernel API, allowing to export kernel pages
# to the userland in more debugger-friendly way. Due to stability
# concerns, not enabled by default yet.
ifdef VBOX_USE_INSERT_PAGE
 KFLAGS  += -DVBOX_USE_INSERT_PAGE
endif

MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)

# build defs
EXTRA_CFLAGS  += -include $(MANGLING) $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

# OL/UEK: disable module signing for external modules -- we don't have any private key
$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) CONFIG_MODULE_SIG= -C $(KERN_DIR) modules

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a; \
	rm -f /etc/vbox/module_not_compiled

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

else # eq ($(MAKECMDGOALS),clean)

 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifeq ($(wildcard $(KERN_DIR)/Makefile),)
   KERN_DIR := /usr/src/linux
  endif
 endif
 ifeq ($(wildcard $(KERN_DIR)/Makefile),)

clean:
	find . \( -name \*.o -o -name \*.cmd \) -print0 | xargs -0 rm -f
	rm -rf .tmp_ver* $(MODULE).* Module.symvers Modules.symvers modules.order

 else

clean:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

 endif

endif # eq($(MAKECMDGOALS),clean)
